/* main.c - initialisation functions
 * AbsVolume was programmed by Paul Sherman, derived in near 
 * entirety from the program "volumecontrol" by Rob Eberts
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License v2.
 * source code is available at <http://www.pcbypaul.com>
 * modified 2007/11/03 Will Davies, converted to a tray widget
 * modified 2007/12/03 Will Davies, supports -bg colour switch
 * modified 2008/03/10 Will Davies, removed -bg support
 * now relies on external png images
 * added -u switch to control tray icon update interval
 * WARNING do not try and learn to program from reading this code
 * I have hacked the original extensively and all the bad programming is mine.
 minimise to tray obtained from 
 http://yettocome.blogspot.com/2007/08/gtk-system-tray-icon-example.html
 gtk_window_set_default_icon_from_file (PIXMAPS_DIR "/hello-icon.gif",NULL);
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <glib.h>
#include <gtk/gtk.h>
#include <fcntl.h>
#include <linux/soundcard.h>
#include "interface.h"


int mixer_fd;
int monitor_volume=-1;
int window1_visible=0;
GtkWidget *window1;
GtkStatusIcon *tray_icon;

void tray_icon_on_click(GtkStatusIcon *status_icon,gpointer user_data){
  if ( window1_visible == 1 ){
    window1_visible = 0;
    if (mixer_fd >-1){
		close(mixer_fd);
 	}
    gtk_widget_destroy (window1);
  }
  else{
    window1 = create_window1 (tray_icon);
  	gtk_window_set_skip_taskbar_hint (GTK_WINDOW(window1),TRUE);//this doesn't seem to work in jwm
  	gtk_widget_show (window1);
  	window1_visible = 1;  	
    g_signal_connect (G_OBJECT(window1), "focus_out_event", G_CALLBACK (tray_icon_on_click),NULL);
  }
}

void tray_icon_on_menu(GtkStatusIcon *status_icon, guint button, guint activate_time, gpointer user_data){
  system("defaultaudiomixer &");
}

main (int argc, char *argv[]){
#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  char *str2 = "none";
int i;
    for (i = 1; i < argc; i++)  /* Skip argv[0] (program name). */
    {
        if ((strcmp(argv[i], "-bg") == 0) && ( (i) < argc)) /* Process arguments. */
        {
            fprintf(stderr, "usage: %s -bg is no longer supported, ignoring.\n Try restarting X to pickup new gtk background colour.\n", argv[0]);
            i++;
        }
        else if ((strcmp(argv[i], "-u") == 0) && ( (i) < argc)) /* Process arguments. */
        {
        	monitor_volume=atoi(argv[i+1]);
        	if (monitor_volume == 0){
        		fprintf(stderr,"%s, ignoring argument to -u switch, %s, trayicon will not autoupdate.\n", argv[0], argv[i+1]);
        	}
            i++;
        } 
        else
        {
        	fprintf(stderr, "usage: %s [-u 1000]\n  -u specifies millisecond interval between updating the icon,\n default is 0, no updating\n", argv[0]);
        exit(1);
        }
    }

  gtk_set_locale ();
  gtk_init(&argc, &argv);
  char *str1 = "  c ";

  tray_icon = gtk_status_icon_new();
  g_signal_connect(G_OBJECT(tray_icon), "activate",G_CALLBACK(tray_icon_on_click), NULL);
  g_signal_connect(G_OBJECT(tray_icon),"popup-menu",G_CALLBACK(tray_icon_on_menu), NULL);
  gtk_status_icon_set_visible(tray_icon, TRUE);
		
  timed_func(NULL);
  if (monitor_volume>0){
  	g_timeout_add(monitor_volume, timed_func,NULL);
  }
  gtk_main ();
close(mixer_fd);
  return 0;
}

